-- Solar addon
--
-- @Author: SolarLoader = {} - Sven "sven777b" Brutigam
-- @Author: Solar = {} - Daniel "Desperados93" Witzel
--
-- @Copyright (): Daniel "Desperados93" Witzel 
-- @Date: 17.06.2012
--

SolarLoader = {};

_G.SolarLoader = SolarLoader;
function SolarLoader.onCreate(id)
	if _G.Solars == nil then
		_G.Solars = {};
	end;
	table.insert(_G.Solars, Solar:new(id));
end;

function SolarLoader:update(dt)
	if _G.Solars ~= nil then
		for k,v in pairs(_G.Solars) do
			v:update(dt);
		end;
	end;
end;

function SolarLoader:delete()
end;
function SolarLoader:loadMap(name)
end;
function SolarLoader:deleteMap()
	if _G.Solars ~= nil then
		for k,v in pairs(_G.Solars) do
			v:delete(dt);
		end;
	end;
end;
function SolarLoader:mouseEvent(posX, posY, isDown, isUp, button)
end;
function SolarLoader:keyEvent(unicode, sym, modifier, isDown)
end;
function SolarLoader:draw()
	if _G.Solars ~= nil then
		for k,v in pairs(_G.Solars) do
			v:draw(dt);
		end;
	end;
end;

Solar = {};
local Solar_mt = Class(Solar);

function Solar:new(id, customMt)
    local self = {};
    if customMt ~= nil then
        setmetatable(self, customMt);
    else
        setmetatable(self, Solar_mt);
    end;

	self.amount = getUserAttribute(id, "anzahl");
	self.profit = getUserAttribute(id, "gewinnProEinheit");
	
	self.unter500 = Utils.indexToObject(id,getUserAttribute(id,"unter500"));
	self.unter1000 = Utils.indexToObject(id,getUserAttribute(id,"unter1000"));
	self.unter1500 = Utils.indexToObject(id,getUserAttribute(id,"unter1500"));
	self.unter2000 = Utils.indexToObject(id,getUserAttribute(id,"unter2000"));
	self.unter2500 = Utils.indexToObject(id,getUserAttribute(id,"unter2500"));
	self.unter3000 = Utils.indexToObject(id,getUserAttribute(id,"unter3000"));
	self.unter3500 = Utils.indexToObject(id,getUserAttribute(id,"unter3500"));
	self.unter4000 = Utils.indexToObject(id,getUserAttribute(id,"unter4000"));
	self.unter4500 = Utils.indexToObject(id,getUserAttribute(id,"unter4500"));
	self.unter5000 = Utils.indexToObject(id,getUserAttribute(id,"unter5000"));
	self.unter5500 = Utils.indexToObject(id,getUserAttribute(id,"unter5500"));
	self.unter6000 = Utils.indexToObject(id,getUserAttribute(id,"unter6000"));
	self.unter6500 = Utils.indexToObject(id,getUserAttribute(id,"unter6500"));
	self.unter7000 = Utils.indexToObject(id,getUserAttribute(id,"unter7000"));
	self.unter7500 = Utils.indexToObject(id,getUserAttribute(id,"unter7500"));
	self.ueber7500 = Utils.indexToObject(id,getUserAttribute(id,"ueber7500"));
	
	
	setVisibility(self.unter500, false);
	setVisibility(self.unter1000, false);
	setVisibility(self.unter1500, false);
	setVisibility(self.unter2000, false);
	setVisibility(self.unter2500, false);
	setVisibility(self.unter3000, false);
	setVisibility(self.unter3500, false);
	setVisibility(self.unter4000, false);
	setVisibility(self.unter4500, false);
	setVisibility(self.unter5000, false);
	setVisibility(self.unter5500, false);
	setVisibility(self.unter6000, false);
	setVisibility(self.unter6500, false);
	setVisibility(self.unter7000, false);
	setVisibility(self.unter7500, false);
	setVisibility(self.ueber7500, false);
	
	
	self.addmoney = self.profit;
	
	self.active = true;
	self.showmoney = 0;
	
	return self;
end;

function Solar:update(dt)
	self.multiply = dt/2

	if self.active == true then
		if g_currentMission.environment.dayTime > 85680000 and g_currentMission.environment.dayTime < 86040000  then
			self.active = false;
				self.addmoney = self.addmoney*self.amount*self.multiply;
					g_currentMission:addSharedMoney(self.addmoney);	
			print("todays solar money:"..self.addmoney);
			self.showmoney = self.addmoney;
			self.addmoney = self.profit;
		end; 
	setVisibility(self.unter500, false);
	setVisibility(self.unter1000, false);
	setVisibility(self.unter1500, false);
	setVisibility(self.unter2000, false);
	setVisibility(self.unter2500, false);
	setVisibility(self.unter3000, false);
	setVisibility(self.unter3500, false);
	setVisibility(self.unter4000, false);
	setVisibility(self.unter4500, false);
	setVisibility(self.unter5000, false);
	setVisibility(self.unter5500, false);
	setVisibility(self.unter6000, false);
	setVisibility(self.unter6500, false);
	setVisibility(self.unter7000, false);
	setVisibility(self.unter7500, false);
	setVisibility(self.ueber7500, false);	
	if self.showmoney <= 0 then
		self.showmoney = 5;
	end;
	
		if self.showmoney <= 500 then
			setVisibility(self.unter500, true);	
		elseif	self.showmoney <= 1000 then
			setVisibility(self.unter1000, true);	
		elseif	self.showmoney <= 1500 then
			setVisibility(self.unter1500, true);	
		elseif	self.showmoney <= 2000 then
			setVisibility(self.unter2000, true);	
		elseif	self.showmoney <= 2500 then
			setVisibility(self.unter2500, true);	
		elseif	self.showmoney <= 3000 then
			setVisibility(self.unter3000, true);	
		elseif	self.showmoney <= 3500 then
			setVisibility(self.unter3500, true);	
		elseif	self.showmoney <= 4000 then
			setVisibility(self.unter4000, true);	
		elseif	self.showmoney <= 4500 then
			setVisibility(self.unter5000, true);	
		elseif	self.showmoney <= 5000 then
			setVisibility(self.unter5000, true);	
		elseif	self.showmoney <= 5500 then
			setVisibility(self.unter5500, true);	
		elseif	self.showmoney <= 6000 then
			setVisibility(self.unter6000, true);	
		elseif	self.showmoney <= 6500 then
			setVisibility(self.unter6500, true);	
		elseif	self.showmoney <= 7000 then
			setVisibility(self.unter7000, true);	
		elseif	self.showmoney <= 7500 then
			setVisibility(self.unter7500, true);	
		elseif	self.showmoney > 7500 then
			setVisibility(self.ueber7500, true);	
		end;
		
	end; 
	if g_currentMission.environment.dayTime > 86040000 and self.active == false then
			self.active = true;
	end;
end; 

function Solar:delete()
end;

function Solar:draw()
end;	

addModEventListener(SolarLoader);
g_onCreateUtil.addOnCreateFunction("SolarOnCreate", SolarLoader.onCreate);